//
//  XZCircleView.m
//  circleView
//
//  Created by 张皓宇 on 2018/1/24.
//  Copyright © 2018年 张皓宇. All rights reserved.
//

#import "XZCircleView.h"

#define PI 3.14159
#define radius self.frame.size.width / 3.8
#define XZRGBColor(r, g, b, a) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:a]

#define angle_start -90

@interface XZCircleView ()

@property (nonatomic, strong) UILabel *label_one;
@property (nonatomic, strong) NSArray *array_name;
@property (nonatomic, strong) NSArray *array_num;
@property (nonatomic, copy) NSString *type;

@end

@implementation XZCircleView

- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        self.backgroundColor = [UIColor whiteColor];
    }
    return self;
}

- (void)layoutSubviews {
    [super layoutSubviews];
    float angle = 360.0 / self.array_name.count;
    float startNum = -90;
    float space = 1.0;

    float start = radians(startNum);
    float half = radians((angle - space) / 2);
    
    float end = radians(startNum + angle - space);
    
    for (int i = 0; i < self.array_name.count; i++) {
        if (i > 0) {
            start = end + radians(space);
            end = start + radians(angle - space);
        }
        
        float y = sin(start + half) * (radius + 16);
        float x = cos(start + half) * (radius + 16 + [self getSizeWidthString:self.array_name[i]].width / 2);
        
        UILabel *label = [self viewWithTag:1000 + i];
        label.center = CGPointMake(self.frame.size.width / 2 + x, self.frame.size.height / 2 + y);
    }
}

static inline float radians(double degrees) {
    return degrees * PI / 180;
}
//数据源
- (void)setStr:(NSString *)str {
    
    if ([self.type isEqualToString:@"0"]) {
        self.array_name = @[@"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐"];
        self.array_num = @[@"0.1", @"0.4", @"0.5", @"0.4", @"1", @"0.9", @"0.9", @"0", @"1", @"1", @"0.2", @"0.4", @"0.5", @"1", @"0.5"];
    }else {
        self.array_name = @[@"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐", @"新年快乐"];
        self.array_num = @[@"0.1", @"0.4", @"0.5", @"0.4", @"1", @"0.9", @"0.9", @"0", @"1", @"1", @"0.2", @"0.4", @"0.5", @"1", @"0.5", @"0.5"];
    }
    [self labelSet];
}

- (void)labelSet {
    for (int i = 0; i < self.array_name.count; i ++) {
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, [self getSizeWidthString:self.array_name[i]].width, 12)];
        label.text = self.array_name[i];
        label.tag = 1000 + i;
        label.font = [UIFont systemFontOfSize:12];
        label.textColor = [UIColor colorWithRed:172 / 255.0 green:172 / 255.0 blue:172 / 255.0 alpha:1];
        label.contentMode = NSTextAlignmentCenter;
        [self addSubview:label];
    }
}


- (void)drawRect:(CGRect)rect {

    CGPoint center = CGPointMake(self.frame.size.width / 2, self.frame.size.height / 2);
    CGContextRef bg = UIGraphicsGetCurrentContext();
    CGContextRef cle_o = UIGraphicsGetCurrentContext();
    CGContextRef ctx = UIGraphicsGetCurrentContext();
        
        
        float angle = 360.0 / self.array_name.count;
        float startNum = -90;
        float space = 1.0;
        
        float start = radians(startNum);
        
        float end = radians(startNum + angle - space);
        
        for (int i = 0; i < self.array_name.count; i++) {
            if (i > 0) {
                start = end + radians(space);
                end = start + radians(angle - space);
            }
            
            CGContextMoveToPoint(bg, center.x, center.y);
            CGContextSetFillColor(bg, CGColorGetComponents(XZRGBColor(247, 247, 247, 1).CGColor));
            CGContextAddArc(ctx, center.x, center.y, radius, start, end, 0);
            CGContextFillPath(ctx);
        
        CGContextMoveToPoint(ctx, center.x, center.y);
            if ([self.type isEqualToString:@"0"]) {
                if (i <= 5) {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:145 / 255.0 green:232 / 255.0 blue:173 / 255.0 alpha:1] CGColor]));
                }else if (i > 5 & i < 11) {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:251 / 255.0 green:218 / 255.0 blue:151 / 255.0 alpha:1] CGColor]));
                }else {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:165 / 255.0 green:223 / 255.0 blue:249 / 255.0 alpha:1] CGColor]));
                }
            }else {
                if (i <= 4) {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:145 / 255.0 green:232 / 255.0 blue:173 / 255.0 alpha:1] CGColor]));
                }else if (i > 4 & i < 11) {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:251 / 255.0 green:218 / 255.0 blue:151 / 255.0 alpha:1] CGColor]));
                }else {
                    CGContextSetFillColor(ctx, CGColorGetComponents([[UIColor colorWithRed:165 / 255.0 green:223 / 255.0 blue:249 / 255.0 alpha:1] CGColor]));
                }
            }
            
        CGContextAddArc(ctx, center.x, center.y, radius * [self.array_num[i] floatValue], start, end, 0);
        CGContextFillPath(ctx);
    }
    for (int i = 1; i < 5; i++) {
        CGContextMoveToPoint(cle_o, center.x, center.y);
        float rad = radius / 5 * i;
        CGContextAddEllipseInRect(cle_o, CGRectMake(center.x - rad, center.y - rad, rad * 2, rad * 2));
        [[UIColor whiteColor] set];
        CGContextStrokePath(cle_o);
    }

}

- (CGSize)getSizeWidthString:(NSString *)str {
    return [str boundingRectWithSize:CGSizeMake(100, 12) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:12]} context:nil].size;
}

@end
